//-----------------------------------------------------
// EJEMPLO2.CPP  -  Programa de ejemplo bajo Windows95.
// Santiago Romero Iglesias AKA NoP / Compiler,
//-----------------------------------------------------
#include <windows.h>

//--- Declaracin de funciones del programa -----------
int WINAPI WinMain( HINSTANCE, HINSTANCE, LPSTR, int );
LRESULT CALLBACK WndProc( HWND, UINT, WPARAM, LPARAM );
void MenuProc( HWND, UINT, WPARAM, LPARAM );

//--- Declaracin de variables del programa -----------
char WindowName[]  = "Default Window";
char WindowTitle[] = "Windows95 application";

//=== Funcin principal WinMain() =====================
int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
				    LPSTR lpCmdLine, int nCmdShow )
{
  HWND hwnd;
  MSG msg;
  WNDCLASSEX wcx;

  // Definimos la estructura de clase:
  wcx.cbSize = sizeof( WNDCLASSEX );
  wcx.style = CS_HREDRAW | CS_VREDRAW;
  wcx.lpfnWndProc = WndProc;
  wcx.cbClsExtra = 0;
  wcx.cbWndExtra = 0;
  wcx.hInstance = hInstance;
	
  // icono, cursor, fondo e icono pequeo:
  wcx.hIcon = LoadIcon(NULL, IDI_WINLOGO);
  wcx.hCursor = LoadCursor(NULL, IDC_ARROW);
  wcx.hbrBackground = (HBRUSH) GetStockObject( WHITE_BRUSH );
  wcx.hIconSm = LoadIcon(NULL, IDI_WINLOGO);
  wcx.lpszClassName = WindowName;
  wcx.lpszMenuName = NULL;

  // Registramos la clase de ventana ya preparada:
  if( !RegisterClassEx( &wcx ) )
      return( FALSE );

  // Creamos la ventana con CreateWindowEx():
  hwnd = CreateWindowEx(
    WS_EX_OVERLAPPEDWINDOW,
    WindowName, WindowTitle,
    WS_OVERLAPPEDWINDOW,
    CW_USEDEFAULT, CW_USEDEFAULT,
    400, 300, NULL, NULL,
    hInstance, NULL
                     );

  // Comprobamos la creacin de la ventana:
  if( !hwnd )
    return( FALSE );

  // Hacemos visible la ventana y la actualizamos:
  ShowWindow( hwnd, nCmdShow );
  UpdateWindow( hwnd );

  // Bucle de mensajes, enva los mensajes hacia WndProc
  while( GetMessage( &msg, NULL, 0, 0 ) )
  {
      TranslateMessage( &msg );
      DispatchMessage( &msg );
  }

  // devolvemos el valor recibido por PostQuitMessage().
  return( msg.wParam );
}


//=== Funcin del procedimiento de ventana WndProc() ====
LRESULT CALLBACK WndProc( HWND hwnd, UINT message, 
						  WPARAM wParam, LPARAM lParam )
{
  HDC hdc;
  PAINTSTRUCT ps;
  TEXTMETRIC tm;
  RECT rect;
  int loop;
  static long cxChar, cyChar;

  switch( message )
  {
    // mensaje producido en la creacin de la ventana
    case WM_CREATE: 
        hdc = GetDC( hwnd );
        GetTextMetrics( hdc, &tm );
        cxChar = tm.tmAveCharWidth;
        cyChar = tm.tmHeight + tm.tmExternalLeading;
        ReleaseDC( hwnd, hdc );
        break;

    case WM_PAINT:
        hdc = BeginPaint( hwnd, &ps );
        GetClientRect( hwnd, &rect );
        for( loop=0; loop<10; loop++ )
          TextOut( hdc, 0,
                   loop*cyChar,
                   "ESTO ES UNA PRUEBA", 18 );
        EndPaint( hwnd, &ps );
        break;

    // mensaje producido al aumentar el tamao de la ventana
    case WM_SIZE:
          // aqui habriamos de coger de nuevo el tamao.
        break;

    // mensaje producido al cerrar la ventana
    case WM_DESTROY:
        PostQuitMessage( 0 );
        break;

    // resto de mensajes, dar una respuesta estndar.
		default:
         return( DefWindowProc( hwnd, message, wParam, lParam ) );
	}

	return(0);
}

//=== Fin del archivo =================================
